/*	Renegade Scripts.dll
	Example implementation of shaders.dll plugin
	Copyright 2007 Mark Sararu

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module 
	that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "scripts.h"
#include "engine_math.h"
#include "shaderplugin.h"
#include "exampleshaderplugin.h"

ShaderCommandClass *ShaderCommands;

void* operator new (size_t nbytes)
{
	return ShaderCommands->AllocateMemory(nbytes);
}

void* operator new[](size_t nbytes)
{
	return ShaderCommands->AllocateMemory(nbytes);
}

void operator delete(void *ptr)
{
	ShaderCommands->DeallocateMemory(ptr);
}

void operator delete[](void *ptr)
{
	ShaderCommands->DeallocateMemory(ptr);
}

extern "C"
{
	BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
	{
		switch (fdwReason)
		{
			case DLL_PROCESS_ATTACH:
				DisableThreadLibraryCalls(hinstDLL);
				break;
			case DLL_PROCESS_DETACH:
				break;
		}
		return TRUE;
	}

	void _declspec(dllexport) SetShaderCommands(ShaderCommandClass *commands)
	{
		ShaderCommands = commands;
	}

	void _declspec(dllexport) GetPluginInterface(ShaderPluginClass **plugin)
	{
		if (plugin)
		{
			*plugin = new ExampleShaderPluginClass();
		}
	}
}

ExampleShaderPluginClass::ExampleShaderPluginClass()
{
	this->InterfaceVersion = SHADERPLUG_INTERFACEVERSION;
}

HRESULT ExampleShaderPluginClass::OnReleaseResources()	
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnReloadResources()
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnDestroyResources()	
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnMapLoad()	
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnMapUnload()	
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnCustom(unsigned int eventid, float parameter)
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnCustom(unsigned int eventid, Vector4 parameter)		
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnFrameStart()
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnFrameEnd()	
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnScreenFadeRender()
{
	return S_CONTINUE;
}

HRESULT ExampleShaderPluginClass::OnRender(unsigned int primitive_type, unsigned short start_index,	unsigned short polygon_count, unsigned short min_vertex_index,	unsigned short vertex_count)
{
	return S_CONTINUE;
}
